TITLE	DEL2	8-27-88	[9-8-88]
;Disassembled with ASMGEN.
;Toad Hall Tweak (tightened, no real functional changes)
;David Kirschbaum
;Toad Hall
;kirsch@braggvax.ARPA

LF	EQU	0AH
CR	EQU	0DH
FCB	EQU	5CH			;file control block offset in PSP

Cseg	SEGMENT
	ASSUME DS:Cseg, SS:Cseg ,CS:Cseg ,ES:Cseg
	ORG	100H

Delete	proc	near
	JMP	Start				;skip over data

;TH moved DTA down to program end (outside code space) to reduce .COM file
;size.
;DTA	DB	50H DUP(0)		;our working Disk Transfer Area

nofilM1	DB	'No matching files.$'

nofilM2	DB	CR,LF,'No more matching files.',CR,LF,'$'

nodelM	DB	'Cannot delete file-- disk write-protected?',CR,LF,'$'

ynprompt DB	CR,LF,'Press Y to delete, N to skip, ESC to stop.'
	db	CR,LF,LF,'$'
delM	DB	9,'Delete $'
;qmarkM	DB	'? $'
yesM	DB	'Yes',CR,LF,'$'
noM	DB	'No'
crlfM	db	CR,LF,'$'			;TH share this CR/LF
stopM	DB	'Stop'
;crlfM	DB	CR,LF,'$'
tabM	DB	9,'$'
okEraM	DB	CR,LF,LF,'Ok to erase? $'
wildOkM	DB	CR,LF,'Is *.* ok (Y or N)'
qmarkM	db	'? $'				;TH share this ?

namebuf	DB	0,'???????????0'		;a constant wildcard name

noquery	DB	0			;set if there's NOT a 'C' parameter
					;(e.g., no query approval for each
					; delete)
colctr	DB	0			;count file name display screen columns


Start:	MOV	DX,OFFSET DTA			;our DTA
	MOV	AH,1AH				;DOS set DTA
	INT	21H
	MOV	SI,80H				;PSP cmd line
	CMP	BYTE PTR [SI],0			;any file parms?
	JNZ	No_Wild_261			;yep
;Assume he wants to delete everything
	MOV	DX,OFFSET wildOkM		;'Is "*.*" ok?'
	MOV	AH,9				;display str
	INT	21H
	MOV	AH,1				;get kbd response
	INT	21H
	AND	AL,5FH				;uppercase
	CMP	AL,'Y'				;Yes?
	JNZ	No_Wild_261			;no wild cards

;He wants a wildcard delete.
;Move a wildcard (all question marks) file name to the PSP's FCB
	MOV	DI,FCB				;to File Control Block in PSP
	MOV	SI,OFFSET namebuf		;from '????????'
	MOV	CX,0DH				;13 chars
	REPZ	MOVSB				;move name into buffer
No_Wild_261:
;I believe DOS puts the first parm (after file name) in FCB #2.
;That's what this program assumes, anyway.
	MOV	SI,6DH				;PSP's FCB #2 +1
	LODSB					;snarf the char there
	AND	AL,5FH				;uppercase
	CMP	AL,'C'				;C parm means query each delete
	JZ	Skp277				;yep
	 MOV	noquery,1			;set the noquery flag
	 MOV	DX,OFFSET crlfM			;CR/LF
	 MOV	AH,9				;display str
	 INT	21H
Skp277:	MOV	DX,FCB				;point to file name in FCB
	MOV	AH,11H				;DOS delete file
	INT	21H
	CMP	AL,0FFH				;0FFH means failed
	JNZ	Del_Ok_28B			;deleted ok
	 MOV	DX,OFFSET nofilM1		;'No matching files'
;	 MOV	AH,9				;display str
;	 INT	21H
;	 INT	20H				;terminate
	 jmp	Msg_Exit			;TH display msg, terminate

Del_Ok_28B:
	CMP	noquery,1			;no queries?
	JZ	Display_Next_2A7		;yep, no prompt, skip
	 MOV	DX,OFFSET ynprompt		;'Press Y to delete,
						; N to skip, ESC to stop'
	 MOV	AH,9				;display str
	 INT	21H

;L0299	  Relup_363 CJ
Fil_Lup_299:
	CMP	noquery,1			;no queries?
	JZ	Display_Next_2A7		;yep, skip the prompt
	 MOV	DX,OFFSET delM			;tab, 'Delete '
	 MOV	AH,9				;display str
	 INT	21H
Display_Next_2A7:
	MOV	SI,OFFSET DTA+1			;start of filename
	MOV	CX,8				;8 chars in file name
Lup2AD:	LODSB
	MOV	DL,AL				;in DL for display
	MOV	AH,2				;display char
	INT	21H
	LOOP	Lup2AD
	MOV	DL,'.'				;add the separator
	MOV	AH,2				;display char
	INT	21H
	MOV	CX,3				;3 chars for type
Lup2BF:	LODSB
	MOV	DL,AL				;in DL for display
	MOV	AH,2				;display char
	INT	21H
	LOOP	Lup2BF

	CMP	noquery,1			;no queries?
	JNZ	Get_Resp_2EA			;nope, get user's response

;Multiple files to display
	INC	colctr				;bump col ctr
	CMP	colctr,5			;max of 5 cols on screen
	JZ	Call_Do_CrLf			;hit 5, new line
	 MOV	DX,OFFSET tabM			;tab over a column
	 MOV	AH,9				;display str
	 INT	21H
	 JMP	SHORT	Find_Next_327

Call_Do_CrLf:
	CALL	Do_CrLf
	JMP	SHORT	Find_Next_327

;L02EA	  L02CD CJ
Get_Resp_2EA:
	MOV	DX,OFFSET qmarkM		;'? '
	MOV	AH,9				;display str
	INT	21H
Lup2F1:	MOV	AH,8				;kbd input w/o echo
	INT	21H
	or	al,al				;TH gobble nulls (fun keys)
	JZ	Lup2F1

	CMP	AL,1BH				;Escape char?
	JZ	Stop_373			;yep, terminate
	CMP	AL,'y'				;yes?
	JZ	Yes_30E				;yep, go say Yes
	CMP	AL,'Y'				;yes?
	JZ	Yes_30E				;yep, go say Yes
	MOV	DX,OFFSET noM			;'No'
	MOV	AH,9				;display str
	INT	21H
	JMP	SHORT	Find_Next_327		;and skip to find next file

Yes_30E:
	MOV	DX,OFFSET yesM			;'Yes'
	MOV	AH,9				;display str
	INT	21H
	MOV	DX,OFFSET DTA			;point to FCB (our DTA)
	MOV	AH,13H				;DOS delete file
	INT	21H
	or	al,al				;TH deleted ok?
	JZ	Find_Next_327			;yep
	 MOV	DX,OFFSET nodelM		;'Can't delete file ..'
	 MOV	AH,9				;display str
	 INT	21H
Find_Next_327:
	MOV	DX,FCB				;FCB pointer
	MOV	AH,12H				;find next
	INT	21H
	CMP	AL,0FFH				;out of matching files?
	JNZ	Relup_363			;nope, keep going

	CMP	noquery,1			;no query?
	JZ	Got_More_342			;right, nonverbose
	 MOV	DX,OFFSET nofilM2		;'No more matching files'
;	 MOV	AH,9				;display str
;	 INT	21H
;	 INT	20H				;terminate
	 jmp	Msg_Exit			;TH new common exit

Got_More_342:
	MOV	DX,OFFSET okEraM		;'Ok to erase?'
	MOV	AH,9				;display str
	INT	21H
	MOV	AH,1				;get kbd response
	INT	21H
	AND	AL,5FH				;uppercase it
	CMP	AL,'Y'				;yes?
	JNZ	NoEra_35A			;nope
	 MOV	DX,FCB				;delete file in FCB
	 MOV	AH,13H				;DOS delete file
	 INT	21H
NoEra_35A:
	MOV	DX,OFFSET crlfM			;display CR/LF
;	MOV	AH,9
;	INT	21H
;	INT	20H				;terminate
	jmp	short Msg_Exit			;TH new common exit

Relup_363:
	JMP	Fil_Lup_299			;loop back
Delete	endp


Do_CrLf	proc	near
	MOV	DX,OFFSET crlfM			;CR/LF
	MOV	AH,9				;display str
	INT	21H
	MOV	colctr,0			;back to first column
	RET
Do_CrLf	endp


Stop_373	proc	near
	MOV	DX,OFFSET stopM			;'Stop'
Msg_Exit:					;TH new common exit
	MOV	AH,9
	INT	21H
;	INT	20H
	mov	ax,4C00H			;TH prefer to end this way
	int	21H
Stop_373	endp

DTA	label	byte		;our 50H-byte working Disk Transfer Area
				;(outside actual code space)

Cseg	ENDS
	END	Delete
